-- Table to hold all the anchor positions used in BeneCast
BeneCast_SnapTo = {};

-- Standard UI anchor positions
BeneCast_SnapTo.STANDARD = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "PlayerFrame", relativePoint = "BOTTOM", x = -10, y = 30 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "PartyMemberFrame1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "PartyMemberFrame2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "PartyMemberFrame3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "PartyMemberFrame4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "PartyMemberFrame1PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "PartyMemberFrame2PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "PartyMemberFrame3PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "PartyMemberFrame4PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "LEFT", frame = "TargetFrame", relativePoint = "RIGHT", x = -20, y = 7 },
	
	AddOn = 'BeneCast',
		
};

-- Perl anchor positions
BeneCast_SnapTo.PERLNYMBIA  = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "Perl_Player_Frame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "Perl_party1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "Perl_party2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "Perl_party3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "Perl_party4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "Perl_Party_Pet1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "Perl_Party_Pet2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "Perl_Party_Pet3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "Perl_Party_Pet4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "Perl_Target_Frame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'Perl',
		
};

-- Perl anchor positions
BeneCast_SnapTo.PERLCLASSIC = {

	-- Player Frame
	BeneCastPanel1 = { point = "BOTTOMLEFT", frame = "Perl_Player_Frame", relativePoint = "TOPRIGHT", x = -5, y = -25 },

	-- Party Frames
	BeneCastPanel2 = { point = "BOTTOMLEFT", frame = "Perl_Party_MemberFrame1", relativePoint = "TOPRIGHT", x = -5, y = -25 },
	BeneCastPanel3 = { point = "BOTTOMLEFT", frame = "Perl_Party_MemberFrame2", relativePoint = "TOPRIGHT", x = -5, y = -25 },
	BeneCastPanel4 = { point = "BOTTOMLEFT", frame = "Perl_Party_MemberFrame3", relativePoint = "TOPRIGHT", x = -5, y = -25 },
	BeneCastPanel5 = { point = "BOTTOMLEFT", frame = "Perl_Party_MemberFrame4", relativePoint = "TOPRIGHT", x = -5, y = -25 },

	-- Player Pet Frame
	BeneCastPanel46 = { point = "TOPLEFT", frame = "BeneCastPanel1", relativePoint = "TOPRIGHT", x = 0, y = 0 },

	-- Party Pet Frames
	BeneCastPanel47 = { point = "BOTTOMLEFT", frame = "Perl_Party_MemberFrame1_StatsFrame_PetHealthBar", relativePoint = "TOPRIGHT", x = -5, y = -25 },
	BeneCastPanel48 = { point = "BOTTOMLEFT", frame = "Perl_Party_MemberFrame2_StatsFrame_PetHealthBar", relativePoint = "TOPRIGHT", x = -5, y = -25 },
	BeneCastPanel49 = { point = "BOTTOMLEFT", frame = "Perl_Party_MemberFrame3_StatsFrame_PetHealthBar", relativePoint = "TOPRIGHT", x = -5, y = -25 },
	BeneCastPanel50 = { point = "BOTTOMLEFT", frame = "Perl_Party_MemberFrame4_StatsFrame_PetHealthBar", relativePoint = "TOPRIGHT", x = -5, y = -25 },

	-- Target Frame
	BeneCastPanel91 = { point = "BOTTOMLEFT", frame = "Perl_Target_Frame", relativePoint = "TOPRIGHT", x = -5, y = -25 },

	AddOn = 'Perl_Target',

};

-- Minigroup anchor positions
BeneCast_SnapTo.MINIGROUP = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "MGParty_Member0", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "MGParty_Member1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "MGParty_Member2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "MGParty_Member3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "MGParty_Member4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "MGTarget_Frame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'MiniGroup',
		
};

-- Minigroup anchor positions
BeneCast_SnapTo.MINIGROUP2 = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "MGplayer", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "MGparty1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "MGparty2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "MGparty3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "MGparty4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "MGpartypet1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "MGpartypet2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "MGpartypet3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "MGpartypet4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "MGtarget", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'MiniGroup2',
		
};

-- Nurfed anchor positions
BeneCast_SnapTo.NURFED = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "Nurfed_player", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "Nurfed_party1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "Nurfed_party2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "Nurfed_party3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "Nurfed_party4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "Nurfed_partypet1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "Nurfed_partypet2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "Nurfed_partypet3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "Nurfed_partypet4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "Nurfed_target", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'Nurfed_UnitFrames',
		
};

-- Noctambul anchor positions
BeneCast_SnapTo.NOCTAMBUL = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "NUFPlayerFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame1", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame2", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame3", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame4", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	--WINTROW.6 START, apparently Noctambul now has decent party-pet frames
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "NUFPartyPet1", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "NUFPartyPet2", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "NUFPartyPet3", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "NUFPartyPet4", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	
	--[[ 
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame1PetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame2PetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame3PetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "NUFPartyMemberFrame4PetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	]]
	--WINTROW.6 STOP
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "NUFTargetFrame", relativePoint = "BOTTOMLEFT", x = 0, y = 0 },
	
	AddOn = 'NUF',
		
};

-- SAE_PartyFrame 
BeneCast_SnapTo.SAE_PARTYFRAME = { 

	-- Player Frame 
	BeneCastPanel1 = { point = "TOPLEFT", frame = "PlayerFrame", relativePoint = "BOTTOM", x = -10, y = 30 }, 

	-- Party Frames 
	BeneCastPanel2 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame1", relativePoint = "TOPRIGHT", x = -5, y = -5 }, 
	BeneCastPanel3 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame2", relativePoint = "TOPRIGHT", x = -5, y = -5 }, 
	BeneCastPanel4 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame3", relativePoint = "TOPRIGHT", x = -5, y = -5 }, 
	BeneCastPanel5 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame4", relativePoint = "TOPRIGHT", x = -5, y = -5 }, 

	-- Player Pet Frame 
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 }, 

	-- Party Pet Frames 
	BeneCastPanel47 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame1PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 2 }, 
	BeneCastPanel48 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame2PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 2 }, 
	BeneCastPanel49 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame3PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 2 }, 
	BeneCastPanel50 = { point = "TOPLEFT", frame = "SAE_PartyMemberFrame4PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 2 }, 

	-- Target Frame 
	BeneCastPanel91 = { point = "LEFT", frame = "TargetFrame", relativePoint = "RIGHT", x = -20, y = 7 }, 

	AddOn = 'SAE_PartyFrame', 
}; 



-- Watchdog anchor positions
BeneCast_SnapTo.WATCHDOG = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "WatchDogFrame_player", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "WatchDogFrame_party1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "WatchDogFrame_party2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "WatchDogFrame_party3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "WatchDogFrame_party4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "WatchDogFrame_partypet1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "WatchDogFrame_partypet2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "WatchDogFrame_partypet3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "WatchDogFrame_partypet4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "WatchDogFrame_target", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'WatchDog',
		
};

-- Discord anchor positions
BeneCast_SnapTo.DISCORD = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "DUF_PlayerFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "DUF_PartyFrame1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "DUF_PartyFrame2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "DUF_PartyFrame3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "DUF_PartyFrame4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Player Pet Frame
	--WINTROW.1 BeneCastPanel46 = { point = "", frame = "", relativePoint = "", x = 0, y = 0 },
	BeneCastPanel46 = { point = "TOPLEFT", frame = "DUF_PetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 }, --WINTROW.1
	
	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "DUF_PartyPetFrame1", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "DUF_PartyPetFrame2", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "DUF_PartyPetFrame3", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "DUF_PartyPetFrame4", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "DUF_TargetFrame", relativePoint = "TOPRIGHT", x = 0, y = 0 },
	
	AddOn = 'DiscordUnitFrames',
		
};

--WINTROW 6 START
BeneCast_SnapTo.CUSTOM = {
	AddOn = 'Custom',	
};

-- Sage anchor positions
BeneCast_SnapTo.SAGE = {

	-- Player Frame
	BeneCastPanel1 = { point = "TOPLEFT", frame = "Splayer", relativePoint = "TOPLEFT", x = 1, y = -45 },

	-- Party Frames
	BeneCastPanel2 = { point = "TOPLEFT", frame = "Sparty1", relativePoint = "TOPRIGHT", x = -2, y = -16 },
	BeneCastPanel3 = { point = "TOPLEFT", frame = "Sparty2", relativePoint = "TOPRIGHT", x = -2, y = -16 },
	BeneCastPanel4 = { point = "TOPLEFT", frame = "Sparty3", relativePoint = "TOPRIGHT", x = -2, y = -16 },
	BeneCastPanel5 = { point = "TOPLEFT", frame = "Sparty4", relativePoint = "TOPRIGHT", x = -2, y = -16 },

	-- Player Pet Frame
	BeneCastPanel46 = { point = "TOPLEFT", frame = "Spet", relativePoint = "TOPRIGHT", x = -2, y = -16 }, --WINTROW.1

	-- Party Pet Frames
	BeneCastPanel47 = { point = "TOPLEFT", frame = "Spartypet1", relativePoint = "TOPRIGHT", x = -2, y = -16 },
	BeneCastPanel48 = { point = "TOPLEFT", frame = "Spartypet2", relativePoint = "TOPRIGHT", x = -2, y = -16 },
	BeneCastPanel49 = { point = "TOPLEFT", frame = "Spartypet3", relativePoint = "TOPRIGHT", x = -2, y = -16 },
	BeneCastPanel50 = { point = "TOPLEFT", frame = "Spartypet4", relativePoint = "TOPRIGHT", x = -2, y = -16 },

	-- Target Frame
	BeneCastPanel91 = { point = "TOPLEFT", frame = "Starget", relativePoint = "TOPRIGHT", x = -2, y = -16 },

	AddOn = 'Sage',

};
--WINTROW 6 STOP

-- Constants used for Blizzard Raid UI pullout frames
local BLIZZ_MAX_RAID_PULLOUT_BUTTONS = 15;
local BLIZZ_MAX_RAID_PULLOUT_FRAMES = 12;

-- Functions for attaching raid panels
-- Functions should take the Raid Id number of a member
-- The BeneCastPanel for a Raid member is always their Raid Id number + 5

--WINTROW.6 START
function BeneCast_AttachRaidPetToRaidPanel(raidmember,raidpet,relativepoint)
	local raidpanel = getglobal(raidmember);
	local petpanel = getglobal(raidpet);
	-- Attach the panel to the frame and set the parent
	petpanel:ClearAllPoints(); --WINTROW.6
	petpanel:SetPoint('TOPLEFT',raidpanel,relativepoint);
	petpanel:SetParent(raidpanel);
	-- Set up the correct frame strata and level for the panel
	petpanel:SetFrameStrata(raidpanel:GetFrameStrata());
	petpanel:SetFrameLevel(raidpanel:GetFrameLevel() + 10);
	-- Set up the correct level for the buttons on the panel
	for x = 1, BENECAST_MAX_NUMBER_OF_BUTTONS do
		getglobal(petpanel:GetName().. 'Button' .. x):SetFrameLevel(petpanel:GetFrameLevel() + 1);
		getglobal(petpanel:GetName().. 'Button' .. x .. 'Cooldown'):SetFrameLevel(petpanel:GetFrameLevel() + 2);
	end
end

function BeneCast_GetRaidPanelFor(parentframe, unitid)
	if not BENECAST_RAID_PANELS[parentframe] then
		for i = 6, 46 do
			if BENECAST_RAID_PANELS2[i] == nil then
				BENECAST_RAID_PANELS[parentframe] = i;
				BENECAST_RAID_PANELS2[i] = { unitid=unitid,
				                             parentframe=parentframe };
				if BENECAST_RAID_PANELS3[unitid] then
					table.insert(BENECAST_RAID_PANELS3[unitid],parentframe);
				else
					BENECAST_RAID_PANELS3[unitid] = { parentframe };
				end
				do break end;
			end
		end
	end
	if not BENECAST_RAID_PANELS[parentframe] then
		for i = 51, 90 do
			if BENECAST_RAID_PANELS2[i] == nil then
				BENECAST_RAID_PANELS[parentframe] = i;
				BENECAST_RAID_PANELS2[i] = { unitid=unitid,
				                             parentframe=parentframe };
				if BENECAST_RAID_PANELS3[unitid] then
					table.insert(BENECAST_RAID_PANELS3[unitid],parentframe);
				else
					BENECAST_RAID_PANELS3[unitid] = { parentframe };
				end
				do break end;
			end
		end
	end
	if not BENECAST_RAID_PANELS[parentframe] then
		if BeneCastConfig.Debug then
			PutDebugMsg('Not enough buttonbars to attach to ' .. parentframe .. ' (' .. UnitName(unitid) .. ')');
			return nil;
		end	
	end
	local id = BENECAST_RAID_PANELS[parentframe];
	if ( id ) then
		if not BENECAST_RAID_PANELS2[id] then
			BENECAST_RAID_PANELS2[id] = { unitid=unitid,
				                      parentframe=parentframe };
		end
		if BENECAST_RAID_PANELS3[unitid] then
			local found = nil;
			for i in BENECAST_RAID_PANELS3[unitid] do
				if BENECAST_RAID_PANELS3[unitid][i] == parentframe then
					found = true;
					do break end;
				end
			end
			if not found then
				table.insert(BENECAST_RAID_PANELS3[unitid],parentframe);
			end
		else
			BENECAST_RAID_PANELS3[unitid] = { parentframe };
		end
	end
	return id;
end
--WINTROW.6 STOP

-- Attach function for the Standard Raid UI (bottom)
function BeneCast_RaidAttachSTANDARDBOTTOM(RaidId, name)

	local raidframe, raidframetext, nextraidframe;
	-- Attach the panel to the correct frame
	--WINTROW.6 local panel = getglobal('BeneCastPanel' .. RaidId + 5);
	for i = 1, BLIZZ_MAX_RAID_PULLOUT_FRAMES do
		for j = 1, BLIZZ_MAX_RAID_PULLOUT_BUTTONS do
			raidframe = getglobal('RaidPullout' .. i .. 'Button' .. j);
			raidframetext = getglobal(raidframe:GetName() .. 'Name'):GetText();
			nextraidframe = nil;
			if ( raidframetext == name and raidframe:IsVisible() ) then
				-- Setup the next raid frame if there it is not the last button in the pullout
				-- And if there's a next frame
				if ( j < BLIZZ_MAX_RAID_PULLOUT_BUTTONS and getglobal('RaidPullout' .. i .. 'Button' .. j+1):IsVisible() ) then
					nextraidframe = getglobal('RaidPullout' .. i .. 'Button' .. j+1);
				else
					nextraidframe = nil;
				end
				--WINTROW.6 START
				-- Dynamically get the panels out of a pool
				local panelid = BeneCast_GetRaidPanelFor(raidframe:GetName(),'raid' .. RaidId);
				local panelname, panel, petpanel;
				if panelid then
					panelname = 'BeneCastPanel' .. panelid;
					panel = getglobal(panelname);
					if ( not panel ) then
						PutDebugMsg('panel ' .. panelname .. ' for raidmember raid' .. RaidId .. ' not found');
					end
				end
				if ( panel ) then
					if BeneCastConfig.ShowRaidPets then
						if UnitExists('raidpet' .. RaidId) then
							panelid = BeneCast_GetRaidPanelFor(panel:GetName(),'raidpet' .. RaidId);
							if panelid then
								panelname = 'BeneCastPanel' .. panelid;					
								petpanel = getglobal(panelname);
							end
						end
					end
				--WINTROW.6 STOP
					-- Attach the panel to the frame and set the parent
					panel:ClearAllPoints(); --WINTROW.6
					panel:SetPoint('TOPLEFT',raidframe,'BOTTOMLEFT');
					panel:SetParent(raidframe);
					-- Set the next raid frame to be underneath the panel
					if ( nextraidframe and BENECAST_RAID_LIST['raid'..RaidId] ) then
						nextraidframe:SetPoint('TOPLEFT',panel,'BOTTOMLEFT');
					end
					-- If the raid unit is not enabled to show a BeneCastPanel move it back
					if ( not BENECAST_RAID_LIST['raid'..RaidId] and nextraidframe ) then
						nextraidframe:SetPoint('TOPLEFT',raidframe,'BOTTOMLEFT',0,-8);
					end
					-- Set up the correct frame strata and level for the panel
					panel:SetFrameStrata(raidframe:GetFrameStrata());
					panel:SetFrameLevel(raidframe:GetFrameLevel() + 10);
					-- Set up the correct level for the buttons on the panel
					for x = 1, BENECAST_MAX_NUMBER_OF_BUTTONS do
						getglobal(panel:GetName().. 'Button' .. x):SetFrameLevel(panel:GetFrameLevel() + 1);
						getglobal(panel:GetName().. 'Button' .. x .. 'Cooldown'):SetFrameLevel(panel:GetFrameLevel() + 2);
					end
					--WINTROW.6 START, --Attach raidpets to panel of raidmember
					if petpanel then
						BeneCast_AttachRaidPetToRaidPanel(panel:GetName(),petpanel:GetName(),'TOPRIGHT');
					end
					--WINTROW.6 STOP
				end --WINTROW.6
			end
		end
	end
	
end

-- Attach function for the Standard Raid UI (right)
function BeneCast_RaidAttachSTANDARDRIGHT(RaidId, name)

	local raidframe, raidframetext, nextraidframe;
	-- Attach the panel to the correct frame
	--WINTROW.6 local panel = getglobal('BeneCastPanel' .. RaidId + 5);
	for i = 1, BLIZZ_MAX_RAID_PULLOUT_FRAMES do
		for j = 1, BLIZZ_MAX_RAID_PULLOUT_BUTTONS do
			raidframe = getglobal('RaidPullout' .. i .. 'Button' .. j);
			raidframetext = getglobal(raidframe:GetName() .. 'Name'):GetText();
			nextraidframe = nil;
			if ( raidframetext == name and raidframe:IsVisible() ) then
				--WINTROW.6 START
				-- Setup the next raid frame if there it is not the last button in the pullout
				-- And if there's a next frame
				if ( j < BLIZZ_MAX_RAID_PULLOUT_BUTTONS and getglobal('RaidPullout' .. i .. 'Button' .. j+1):IsVisible() ) then
					nextraidframe = getglobal('RaidPullout' .. i .. 'Button' .. j+1);
				else
					nextraidframe = nil;
				end
				-- Dynamically get the panels out of a pool
				local panelid = BeneCast_GetRaidPanelFor(raidframe:GetName(),'raid' .. RaidId);
				local panelname, panel, petpanel;
				if panelid then
					panelname = 'BeneCastPanel' .. panelid;
					panel = getglobal(panelname);
					if ( not panel ) then
						PutDebugMsg('panel ' .. panelname .. ' for raidmember raid' .. RaidId .. ' not found');
					end
				end
				if ( panel ) then
					if BeneCastConfig.ShowRaidPets then
						if UnitExists('raidpet' .. RaidId) then
							panelid = BeneCast_GetRaidPanelFor(panel:GetName(),'raidpet' .. RaidId);
							if panelid then
								panelname = 'BeneCastPanel' .. panelid;					
								petpanel = getglobal(panelname);
							end
						end
					end
				--WINTROW.6 STOP
					-- Attach the panel to the frame and set the parent
					panel:SetPoint('TOPLEFT',raidframe,'TOPRIGHT');
					panel:SetParent(raidframe);
					--WINTROW.6 START
					if nextraidframe then
						nextraidframe:SetPoint('TOPLEFT',raidframe,'BOTTOMLEFT',0,-8);
					end
					--WINTROW.6 STOP
					-- Set up the correct frame strata and level for the panel
					panel:SetFrameStrata(raidframe:GetFrameStrata());
					panel:SetFrameLevel(raidframe:GetFrameLevel() + 10);
					-- Set up the correct level for the buttons on the panel
					for x = 1, BENECAST_MAX_NUMBER_OF_BUTTONS do
						getglobal(panel:GetName().. 'Button' .. x):SetFrameLevel(panel:GetFrameLevel() + 1);
						getglobal(panel:GetName().. 'Button' .. x .. 'Cooldown'):SetFrameLevel(panel:GetFrameLevel() + 2);
					end
					--WINTROW.6 START, --Attach raidpets to panel of raidmember
					if petpanel then
						BeneCast_AttachRaidPetToRaidPanel(panel:GetName(),petpanel:GetName(),'BOTTOMLEFT');
						if nextraidframe then
							nextraidframe:SetPoint('TOPLEFT',raidframe,'BOTTOMLEFT',0,-8 - petpanel:GetHeight());
						end
					end
					--WINTROW.6 STOP
				end --WINTROW.6
			end
		end
	end
	
end

-- Attach function for CT_RA (bottom)
function BeneCast_RaidAttachCT_RAIDBOTTOM(RaidId, name)

	local raidframe, raidframetext, nextraidframe;
	-- Attach the panel to the correct frame
	--WINTROW.6 local panel = getglobal('BeneCastPanel' .. RaidId + 5);
	for i = 1, MAX_RAID_MEMBERS do
		raidframe = getglobal('CT_RAMember' .. i);
		raidframetext = getglobal(raidframe:GetName() .. 'Name'):GetText();
		nextraidframe = nil;
		if ( raidframetext == name and raidframe:IsVisible() ) then
			-- Setup the next raid frame if there it is not the last button in the pullout
			if ( raidframe.next ) then
				nextraidframe = raidframe.next;
			else
				nextraidframe = nil;
			end
			--WINTROW.6 START
			-- Dynamically get the panels out of a pool
			local panelid = BeneCast_GetRaidPanelFor(raidframe:GetName(),'raid' .. RaidId);
			local panelname, panel, petpanel;
			if panelid then
				panelname = 'BeneCastPanel' .. panelid;
				panel = getglobal(panelname);
				if ( not panel ) then
					PutDebugMsg('panel ' .. panelname .. ' for raidmember raid' .. RaidId .. ' not found');
				end
			end
			if ( panel ) then
				if BeneCastConfig.ShowRaidPets then
					if UnitExists('raidpet' .. RaidId) then
						panelid = BeneCast_GetRaidPanelFor(panel:GetName(),'raidpet' .. RaidId);
						if panelid then
							panelname = 'BeneCastPanel' .. panelid;					
							petpanel = getglobal(panelname);
						end
					end
				end
			--WINTROW.6 STOP
				-- Attach the panel to the frame and set the parent
				panel:SetPoint('TOPLEFT',raidframe,'BOTTOMLEFT');
				panel:SetParent(raidframe);
				-- Set the next raid frame to be underneath the panel
				if ( nextraidframe and BENECAST_RAID_LIST['raid'..RaidId] ) then
					nextraidframe:SetPoint('TOPLEFT',panel,'BOTTOMLEFT');
				end
				-- If the raid unit is not enabled to show a BeneCastPanel move it back
				if ( not BENECAST_RAID_LIST['raid'..RaidId] and nextraidframe ) then
					nextraidframe:SetPoint('TOPLEFT',raidframe,'BOTTOMLEFT',0,0);
				end
				-- Set up the correct frame strata and level for the panel
				panel:SetFrameStrata(raidframe:GetFrameStrata());
				panel:SetFrameLevel(raidframe:GetFrameLevel() + 10);
				-- Set up the correct level for the buttons on the panel
				for x = 1, BENECAST_MAX_NUMBER_OF_BUTTONS do
					getglobal(panel:GetName().. 'Button' .. x):SetFrameLevel(panel:GetFrameLevel() + 1);
					getglobal(panel:GetName().. 'Button' .. x .. 'Cooldown'):SetFrameLevel(panel:GetFrameLevel() + 2);
				end
				--WINTROW.6 START, --Attach raidpets to panel of raidmember
				if petpanel then
					BeneCast_AttachRaidPetToRaidPanel(panel:GetName(),petpanel:GetName(),'TOPRIGHT');
				end
				--WINTROW.6 STOP
			end --WINTROW.6
		end
	end
	
end

-- Attach function for CT_RA (right)
function BeneCast_RaidAttachCT_RAIDRIGHT(RaidId, name)

	local raidframe, raidframetext, nextraidframe;
	-- Attach the panel to the correct frame
	--WINTROW.6 local panel = getglobal('BeneCastPanel' .. RaidId + 5);
	for i = 1, MAX_RAID_MEMBERS do
		raidframe = getglobal('CT_RAMember' .. i);
		raidframetext = getglobal(raidframe:GetName() .. 'Name'):GetText();
		nextraidframe = nil;
		if ( raidframetext == name and raidframe:IsVisible() ) then
			--WINTROW.6 START
			-- Setup the next raid frame if there it is not the last button in the pullout
			if ( raidframe.next ) then
				nextraidframe = raidframe.next;
			else
				nextraidframe = nil;
			end
			-- Dynamically get the panels out of a pool
			local panelid = BeneCast_GetRaidPanelFor(raidframe:GetName(),'raid' .. RaidId);
			local panelname, panel, petpanel;
			if panelid then
				panelname = 'BeneCastPanel' .. panelid;
				panel = getglobal(panelname);
				if ( not panel ) then
					PutDebugMsg('panel ' .. panelname .. ' for raidmember raid' .. RaidId .. ' not found');
				end
			end
			if ( panel ) then
				if BeneCastConfig.ShowRaidPets then
					if UnitExists('raidpet' .. RaidId) then
						panelid = BeneCast_GetRaidPanelFor(panel:GetName(),'raidpet' .. RaidId);
						if panelid then
							panelname = 'BeneCastPanel' .. panelid;					
							petpanel = getglobal(panelname);
						end
					end
				end
			--WINTROW.6 STOP
				-- Attach the panel to the frame and set the parent
				panel:SetPoint('TOPLEFT',raidframe,'TOPRIGHT');
				panel:SetParent(raidframe);
				--WINTROW.6 START
				if ( nextraidframe ) then
					nextraidframe:SetPoint('TOPLEFT',raidframe,'BOTTOMLEFT',0,0);
				end
				--WINTROW.6 STOP
				-- Set up the correct frame strata and level for the panel
				panel:SetFrameStrata(raidframe:GetFrameStrata());
				panel:SetFrameLevel(raidframe:GetFrameLevel() + 10);
				-- Set up the correct level for the buttons on the panel
				for x = 1, BENECAST_MAX_NUMBER_OF_BUTTONS do
					getglobal(panel:GetName().. 'Button' .. x):SetFrameLevel(panel:GetFrameLevel() + 1);
					getglobal(panel:GetName().. 'Button' .. x .. 'Cooldown'):SetFrameLevel(panel:GetFrameLevel() + 2);
				end
				--WINTROW.6 START, --Attach raidpets to panel of raidmember
				if petpanel then
					BeneCast_AttachRaidPetToRaidPanel(panel:GetName(),petpanel:GetName(),'BOTTOMLEFT');
					if nextraidframe then
						nextraidframe:SetPoint('TOPLEFT',raidframe,'BOTTOMLEFT',0,-petpanel:GetHeight());
					end
				end
				--WINTROW.6 STOP
			end --WINTROW.6
		end
	end
	
end

-- Table for raid AddOn options in BeneCast
BeneCast_RaidSnapTo = {};

-- Standard UI Raid Anchors
BeneCast_RaidSnapTo.STANDARDBOTTOM = {

	AddOn = 'BeneCast',
	Funct = BeneCast_RaidAttachSTANDARDBOTTOM,

}

BeneCast_RaidSnapTo.STANDARDRIGHT = {

	AddOn = 'BeneCast',
	Funct = BeneCast_RaidAttachSTANDARDRIGHT,

}

-- CT_Raid Anchors
BeneCast_RaidSnapTo.CT_RAIDBOTTOM = {

	AddOn = 'CT_RaidAssist',
	Funct = BeneCast_RaidAttachCT_RAIDBOTTOM,

}

BeneCast_RaidSnapTo.CT_RAIDRIGHT = {

	AddOn = 'CT_RaidAssist',
	Funct = BeneCast_RaidAttachCT_RAIDRIGHT,

}
